module Equality where

open import Utils
open import Term
open import Value
open import Recursive

eqˣ : forall {Γ}{σ}{σ'} -> Var Γ σ -> Var Γ σ' -> Maybe (σ == σ')
eqˣ vZ     vZ      = Just refl⁼
eqˣ (vS v) (vS v') = eqˣ v v'
eqˣ _      _       = Nothing

mutual
  eq : forall {Γ}{σ} -> (v v' : Val Γ σ) -> Maybe True
  eq {σ = σ → τ} f f' =
     eq (wkv σ f $$ (nev (var vZ))) (wkv σ f' $$ (nev (var vZ)))
  eq {σ = N}  Zv      Zv      = Just tt
  eq {σ = N} (Sv v)  (Sv v')  = eq v v'
  eq {σ = N} (nev n) (nev n') with eqⁿ n n'
  ...                         | Just _  = Just tt
  ...                         | Nothing = Nothing
  eq {σ = N} _       _        = Nothing

  eqⁿ : forall {Γ}{σ σ'} -> Ne Val Γ σ -> Ne Val Γ σ' -> Maybe (σ == σ')
  eqⁿ (var v)   (var v')    = eqˣ v v'
  eqⁿ (app n v) (app n' v') with eqⁿ n n'
  ...                       | Just refl⁼ with eq v v'
  ...                                    | Just tt = Just refl⁼ 
  ...                                    | Nothing = Nothing
  ...                       | Nothing = Nothing  

