module Soundness where
open import Utils
open import Term
open import Value
open import Normal
open import Recursive
open import Renaming
open import StrongComp
open import StrongConv

mutual
  thrm12a : forall {Γ Δ}{σ}{t t' : Tm Δ σ} -> t ≡ t' -> {vs vs' : Env Γ Δ} ->
            vs ≃ˢ vs' -> ev t vs ≃ ev t' vs'
  thrm12a {t = t}{t' = .t} refl p = lem9a t p
  thrm12a {σ = σ} (sym p) p' = esym {σ = σ} (thrm12a p (esymˢ p')) 
  thrm12a {σ = σ} (trans p p') {vs} {vs'} p'' = 
    etrans {σ = σ} (thrm12a p (etransˢ p'' (esymˢ p''))) (thrm12a p' p'') 

  thrm12a {σ = σ → τ}(λ≡ {t = t}{t' = t'} p){vs}{vs'} p' = \Δ a a' p'' -> 
    helpλ (wkv++ Δ (λv t vs))
          (wkv++ Δ (λv t' vs'))
          (λv t (wke++ Δ vs))
          (λv t' (wke++ Δ vs'))
          (lemλwk t vs Δ)
          (lemλwk t' vs' Δ)
          a 
          a' 
          (thrm12a p (e◂ (lem8b Δ p') p''))
  thrm12a ($≡ p {u}{u'} p'){vs}{vs'} p'' =
    thrm12a p p'' ε (ev u vs) (ev u' vs') (thrm12a p' p'')
  thrm12a ([]≡ p p') p'' = thrm12a p (thrm12b p' p'')
  thrm12a (S≡ p) p'' = eS (thrm12a p p'')
  thrm12a (pr≡ p p' p'') p''' = prhelp (thrm12a p p''')
                                       (thrm12a p' p''')
                                       (thrm12a p'' p''')
  thrm12a (ø≡ {t = t}) p = lem9a t p
  thrm12a ([][]≡ {t = t}{ts = ts}{us = us}) p = 
    lem9a t (lem9b ts (lem9b us p))
  thrm12a ($[]≡ {t = t}{u = u}{ts = ts}){vs}{vs'} p =
   lem9a t 
         (lem9b ts p)
         ε
        (ev u (evˢ ts vs))
        (ev u (evˢ ts vs')) 
        (lem9a u (lem9b ts p))      
  thrm12a {σ = σ → τ} (λ[]≡ {t = t}{ts = ts}){vs}{vs'} p = \Δ a a' p' ->
   helpλ (wkv++ Δ (λv t (evˢ ts vs))) 
         (wkv++ Δ (λv (t [ (ts ○ ↑ σ) ◃ ø ]) vs'))
         (λv t (wke++ Δ (evˢ ts vs )))
         (λv (t [ (ts ○ ↑ σ) ◃ ø ]) (wke++ Δ vs'))
         (lemλwk t (evˢ ts vs) Δ)
         (lemλwk (t [ (ts ○ ↑ σ) ◃ ø ]) vs' Δ)
         a 
         a' 
         (lem9a t (e◂ (etransˢ (eˢhelp (lemevˢ++ ts vs Δ) refl⁼ (lem9b ts (lem8b Δ (etransˢ p (esymˢ p)))))
                               (lem9b ts (lem8b Δ p))) p'))
  thrm12a Z[]≡ p = eZ
  thrm12a (S[]≡{_}{_}{ts}{n}){vs}{vs'} p = eS (lem9a n (lem9b ts p))  
  thrm12a (pr[]≡ {_}{_}{_}{t}{f}{z}{ts}) p = 
    prhelp (lem9a t (lem9b ts p))
           (lem9a f (lem9b ts p))
           (lem9a z (lem9b ts p)) 
  thrm12a (prZ≡ {z = z}) p = lem9a z p 
  thrm12a (prS≡ {_}{_}{f}{z}{n}){vs}{vs'} p =
    lem9a f p ε (ev n vs) (ev n vs') (lem9a n p) 
               ε (primv (ev n vs) (ev f vs) (ev z vs))
                 (primv (ev n vs') (ev f vs') (ev z vs'))
                 (prhelp (lem9a n p) (lem9a f p) (lem9a z p))
  thrm12a (βσ {t = t}{ts = ts}{u = u}){vs}{vs'} p =
    lem9a t (e◂ (lem9b ts p) (lem9a u p))
  thrm12a {σ = σ → τ} (η {f = f}){vs}{vs'} p = \Δ a a' p' ->
    helpλ (wkv++ Δ (ev f vs))
          (wkv++ Δ (ev (λ ((f [ ↑ σ ]) $ ø )) vs'))
          (ev f (wke++ Δ vs))
          (ev (λ ((f [ ↑ σ ]) $ ø)) (wke++ Δ vs'))
          (lemev++ f vs Δ)
          (lemλwk ((f [ ↑ σ ]) $ ø) vs' Δ )
          a 
          a' 
          (lem9a f (lem8b Δ p) ε a a' p')
  thrm12a (id≡ {t = t}) p = lem9a t p

  thrm12b : forall {B Γ Δ}{ts ts' : Tmˢ Γ Δ} -> ts ≡ˢ ts' -> 
            {vs vs' : Env B Γ} -> vs ≃ˢ vs' -> evˢ ts vs ≃ˢ evˢ ts' vs'
  thrm12b (reflˢ {ts = ts}) p = lem9b ts p
  thrm12b (symˢ p) p' = esymˢ (thrm12b p (esymˢ p'))
  thrm12b (transˢ p p'){vs} p'' = etransˢ (thrm12b p (etransˢ p'' (esymˢ p''))) (thrm12b p' p'') 
  thrm12b (◃≡ p p') p'' = e◂ (thrm12b p p'') (thrm12a p' p'')
  thrm12b (○≡ p p') p'' = thrm12b p (thrm12b p' p'')
  thrm12b ◃id≡ˢ (e◂ p p') = e◂ p p'
  thrm12b (↑◃≡ˢ {ts = ts}) p = lem9b ts p     
  thrm12b (○○≡ˢ {ts = ts}{us = us}{vs = vs}) p = 
    lem9b ts (lem9b us (lem9b vs p)) 
  thrm12b (○◃≡ˢ {ts = ts}{t = t}{us = us}) p =
    e◂ (lem9b ts (lem9b us p)) (lem9a t (lem9b us p))

prop13 : forall {Γ}{σ}{t t' : Tm Γ σ} -> t ≡ t' -> nf t == nf t'
prop13 {Γ}{σ} p = lem10a σ (thrm12a {Γ}{Γ}{σ} p (cor11b Γ))   