module Stability where

open import Utils
open import Term
open import Value
open import Normal
open import Recursive
open import Renaming


{- this is proves a property of a program that doesn't termination check and
   hence itself doesn't check. -}
mutual
  comevwk : forall {Γ Δ}{σ} τ (t : Tm Δ σ)(vs : Env Γ Δ) -> 
         ev t (wke τ vs) == wkv τ (ev t vs)
  comevwk τ ø     (vs ◂ v) = refl⁼
  comevwk τ (λ t) vs = refl⁼
  comevwk τ (t $ u) vs = trans⁼ (resp2 (\f a -> f $$ a) 
                                    (comevwk τ t vs) 
                                    (comevwk τ u vs))
                             (comevwk$ τ (ev t vs) (ev u vs))
  comevwk τ (t [ ts ]) vs with evˢ ts (wke τ vs) | comevwkˢ τ ts vs 
  ... | ._ | refl⁼ = comevwk τ t (evˢ ts vs)
  comevwk τ Z vs = refl⁼
  comevwk τ (S t) vs = resp (\v -> Sv v) (comevwk τ t vs)   
  comevwk τ (pr n f z) vs = trans⁼ (resp3 (\n f z -> primv n f z)
                                        (comevwk τ n vs)
                                        (comevwk τ f vs)
                                        (comevwk τ z vs))
                                 (comevwkpr τ (ev n vs) (ev f vs) (ev z vs))

  comevwkpr : forall {Γ}{σ} τ (n : Val Γ N)(f : Val Γ (N → σ → σ))(z : Val Γ σ) ->
           primv (wkv τ n) (wkv τ f) (wkv τ z) == wkv τ (primv n f z)
  comevwkpr τ Zv      f z = refl⁼ 
  comevwkpr τ (Sv v)  f z with wkv τ (f $$ v $$ primv v f z) | comevwk$ τ (f $$ v) (primv v f z) 
  ... | ._ | refl⁼ with wkv τ (f $$ v) | comevwk$ τ f v 
  ... | ._ | refl⁼ with wkv τ (primv v f z) | comevwkpr τ v f z
  ... | ._ | refl⁼ = refl⁼ 
  comevwkpr τ (nev n) f z = refl⁼ 

  comevwk$ : forall {Γ}{σ τ} ρ (f : Val Γ (σ → τ))(a : Val Γ σ) ->
          wkv ρ f $$ wkv ρ a == wkv ρ (f $$ a) 
  comevwk$ τ (λv t vs) a = comevwk τ t (vs ◂ a) 
  comevwk$ τ (nev n)   a = refl⁼ 


  comevwkˢ : forall {B Γ Δ} τ (ts : Tmˢ Γ Δ)(vs : Env B Γ) ->
         evˢ ts (wke τ vs) == wke τ (evˢ ts vs)
  comevwkˢ τ id vs = refl⁼ 
  comevwkˢ τ (ts ◃ t) vs = resp2 (\vs v -> vs ◂ v)
                               (comevwkˢ τ ts vs)
                               (comevwk τ t vs) 
  comevwkˢ τ (↑ σ) (vs ◂ v) = refl⁼
  comevwkˢ τ (ts ○ us) vs with evˢ us (wke τ vs) | comevwkˢ τ us vs
  ... | ._ | refl⁼ = comevwkˢ τ ts (evˢ us vs) 

prop7var : forall {Γ}{σ}(v : Var Γ σ) ->
    (ev ⌜ v ⌝ˣ (ide {Γ}) == nev (var v))
prop7var vZ = refl⁼ 
prop7var {Γ = Γ , σ} (vS v) = trans⁼ (comevwk σ ⌜ v ⌝ˣ ide) 
                          (resp (\v -> wkv σ v) (prop7var v))

mutual
  prop7a : forall {Γ}{σ}(n : Nf Γ σ) -> 
            (nf ⌜ n ⌝ == n)
  prop7a {Γ} {N} (nen n) with ev ⌜ n ⌝ⁿ ide | prop7b n
  ... | .(nev n') | sig n' (pa refl⁼ p) = resp (\n -> nen n) p 
  prop7a {Γ} (λn n) = resp (\n -> λn n) (prop7a n)  

  prop7b : forall {Γ}{σ}(n : Ne Nf Γ σ) ->
    Σ (Ne Val Γ σ) \n' -> (ev ⌜ n ⌝ⁿ ide == nev n') × (quoteⁿ n' == n)
  prop7b (var v) = sig (var v) (pa (prop7var v) refl⁼)
  prop7b (app n n') with ev ⌜ n ⌝ⁿ ide | prop7b n
  ... | ._ | sig n'' (pa refl⁼ p) = sig (app n'' (ev ⌜ n' ⌝ ide)) 
                                        (pa refl⁼ 
                                            (resp2 (\n v -> app n v) p pn'))
    where
    pn' = prop7a n'