module StrongComp where
open import Utils
open import Term
open import Value
open import Normal
open import BigStep
open import Renaming

data SCN {Γ : Cn} : Val Γ N -> Set where
  sZ : SCN Zv
  sS : forall {v} -> SCN v -> SCN (Sv v)
  sN : forall {n} -> 
       Σ (Ne Nf Γ N) (\n' -> (qⁿ n ⇓ n' × (⌜ n ⌝ʷⁿ ≡ ⌜ n' ⌝ⁿ))) ->
       SCN (nev n)

SCV : forall {Γ}{σ} -> Val Γ σ -> Set
SCV {Γ}{N}     v = SCN v
SCV {Γ}{σ → τ} f = forall Δ (a : Val (Γ ++ Δ) σ) -> SCV a ->  
  Σ (Val (Γ ++ Δ) τ) 
    \v -> (wkv++ Δ f $ a ⇓ v) ∧  ⌜ wkv++ Δ f ⌝ʷ $ ⌜ a ⌝ʷ ≡ ⌜ v ⌝ʷ  ∧ SCV v

SCE : forall {Γ}{Δ} -> Env Γ Δ -> Set
SCE e = True
SCE (vs ◂ v) = SCE vs × SCV v

schelp : forall {Γ}{σ}{v v' : Val Γ σ} -> v == v' -> SCV v -> SCV v'
schelp {v = v}{v' = .v} refl⁼ p = p

lem2a : forall {Γ}{σ} Δ (v : Val Γ σ) -> SCV v -> SCV (wkv++ Δ v)
lem2a {Γ}{N} Δ Zv sZ = schelp (lemZwk Δ) sZ
lem2a {Γ}{N} Δ (Sv v) (sS sv) =
  schelp (lemSwk v  Δ) (sS (lem2a Δ v sv)) 
lem2a {Γ}{N} Δ (nev n) (sN (sig n' (pa p q))) =
  schelp (lemNwk n Δ) 
         (sN (sig (wknef++ n' Δ) (pa (wkqn p Δ) (wk⌜⌝ⁿ {Γ}{N}{n}{n'} q Δ))))  

lem2a {Γ}{σ → τ} Δ f sf =  \Δ' a sa ->
  lemma2aHelp (assoc Γ Δ Δ')
              (wkv++ Δ' (wkv++ Δ f))
              (wkv++ (Δ ++ Δ') f)
              (lemwk Γ Δ Δ' f) 
              a
              sa
              (sf (Δ ++ Δ')) 
  where
  lemma2aHelp : forall {σ}{τ}{Θ Θ' : Cn} -> (Θ == Θ') -> (f : Val Θ (σ → τ)) ->
    (f' : Val Θ' (σ → τ)) -> (f == f') -> (a : Val Θ σ) -> SCV a ->
    ((a : Val Θ' σ) -> SCV a ->
    Σ (Val Θ' τ) \v -> (f' $ a ⇓ v) ∧  ⌜ f' ⌝ʷ $ ⌜ a ⌝ʷ ≡ ⌜ v ⌝ʷ ∧ SCV v) -> 
    Σ (Val Θ  τ) \v -> (f $ a ⇓ v) ∧ ⌜ f ⌝ʷ $ ⌜ a ⌝ʷ ≡ ⌜ v ⌝ʷ ∧  SCV v
  lemma2aHelp refl⁼ f .f refl⁼ a sa H  = H a sa 


lem2b : forall {Γ}{Δ} Γ' (vs : Env Γ Δ) -> SCE vs -> SCE (wke++ Γ' vs)
lem2b ε       vs se = se
lem2b (Γ , σ) vs se =  lem (wke++ Γ vs) (lem2b Γ vs se) σ where
    lem : {B Δ : Cn} -> (vs : Env B Δ) -> SCE vs -> (σ : Ty) -> SCE (wke σ vs)
    lem e void σ = void
    lem (vs ◂ v) (pa se sv) σ =  pa (lem vs se σ) (lem2a (ε , σ) v sv)
